VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "netCFRONT2"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'' Navision 3.60 CFRONT proxy for .NET
'' Eliminated all "Variant" values
''
'' Created by Alexey Pavlov, 2003
''
'' email: ap@rd.lv, alexey_pavlov@fastnet.lv
''
'' You can perform any modifications of source code
''
'' Usage:
''    InitializeCFRONT() - original CFRONT.OCX component initialization
''    DestroyCFRONT()    - CFRONT.OCX unloading
''    All other methods are reimplemented or extended for specific data type
''    All field references replaced to "by name", not by ID

Public InternalCFRONT As CFRONT
Public CFActive As Boolean

Private CalcFieldsCount As Long
Private CalcFieldsNameArr As Variant
Private InternalCalcFieldsCollection As Collection

Public Sub Create()

End Sub

Public Sub Dispose()

End Sub

Public Sub InitializeCFRONT()
  Set InternalCFRONT = New CFRONT
  CFActive = True
  Set InternalCalcFieldsCollection = New Collection
End Sub

Public Sub DestroyCFRONT()
  Set InternalCFRONT = Nothing
  CFActive = False
End Sub

Public Sub OpenDatabase(ByVal DatabaseName As String, ByVal CacheSize As Long, _
    ByVal UseComminCache As Boolean)
  InternalCFRONT.OpenDatabase DatabaseName, CacheSize, UseComminCache
End Sub

Public Sub CloseDatabase()
  InternalCFRONT.CloseDatabase
End Sub

Public Sub SetNavisionPath(ByVal Path As String)
  InternalCFRONT.SetNavisionPath Path
End Sub

Public Sub LoadLicenseFile(ByVal FileName As String)
  InternalCFRONT.LoadLicenseFile FileName
End Sub

Public Sub CheckLicenseFile(ByVal ObjectNo As Long)
  InternalCFRONT.CheckLicenseFile ObjectNo
End Sub

Public Sub ConnectServer(ByVal ServerName As String, ByVal NetType As String)
  InternalCFRONT.ConnectServer ServerName, NetType
End Sub

Public Sub DisconnectServer()
  InternalCFRONT.DisconnectServer
End Sub

Public Function Login(ByVal UserID As String, ByVal PassWord As String) As Boolean
  Login = InternalCFRONT.Login(UserID, PassWord)
End Function

Public Sub ConnectServerAndOpenDatabase(ByVal DriverName As String, ByVal ServerName As String, _
    ByVal NetType As String, ByVal DatabaseName As String, ByVal CacheSize As Long, _
    ByVal UseCommitCache As Boolean, _
    ByVal NTAuthorization As Boolean, ByVal UserID As String, ByVal PassWord As String)
  InternalCFRONT.ConnectServerAndOpenDatabase DriverName, ServerName, NetType, DatabaseName, CacheSize, UseCommitCache, NTAuthorization, UserID, PassWord
End Sub

Public Sub OpenCompany(ByVal CompanyName As String)
  InternalCFRONT.OpenCompany CompanyName
End Sub

Public Sub CloseCompany()
  InternalCFRONT.CloseCompany
End Sub

Public Sub ReleaseAllObjects()
  InternalCFRONT.ReleaseAllObjects
End Sub

'
' Error handling
'
'
Public Sub SetStopOnAllExceptions(ByVal StopOnAllExceptions As Boolean)
  InternalCFRONT.StopOnAllExceptions = StopOnAllExceptions
End Sub

Public Sub AllowKeyNotFound()
  InternalCFRONT.AllowKeyNotFound
End Sub

Public Sub AllowRecordExists()
  InternalCFRONT.AllowRecordExists
End Sub

Public Sub AllowRecordNotFound()
  InternalCFRONT.AllowRecordNotFound
End Sub

Public Sub AllowTableNotFound()
  InternalCFRONT.AllowTableNotFound
End Sub

Public Function GetLastError() As Long
  GetLastError = InternalCFRONT.LastError
End Function

Public Sub ClearLastError()
  InternalCFRONT.LastError
End Sub

Public Sub SetHideError(ByVal HideError As Boolean)
  InternalCFRONT.HideError = HideError
End Sub

' ------------------------------------------
' Table/Record routines
' ------------------------------------------
'
Public Function OpenTableByName(ByVal TableName As String) As Long
Dim hTable As Long
  InternalCFRONT.OpenTable hTable, InternalCFRONT.TableNo(TableName)
  OpenTableByName = hTable
End Function

Public Function OpenTableByID(ByVal TableID As Long) As Long
Dim hTable As Long
  InternalCFRONT.OpenTable hTable, TableID
  OpenTableByID = hTable
End Function

Public Sub CloseTable(ByVal hTable As Long)
  InternalCFRONT.CloseTable hTable
End Sub

Public Function AllocRec(ByVal hTable As Long) As Long
  AllocRec = InternalCFRONT.AllocRec(hTable)
End Function

Public Sub FreeRec(ByVal hRec As Long)
  InternalCFRONT.FreeRec hRec
End Sub

Public Function InitRec(ByVal hTable As Long, ByVal hRec As Long) As Long
  InternalCFRONT.InitRec hTable, hRec
End Function

Public Function FindRec(ByVal hTable As Long, ByVal hRec As Long, ByVal SearchMethod As String)
  FindRec = InternalCFRONT.FindRec(hTable, hRec, SearchMethod)
End Function

Public Function NextRec(ByVal hTable As Long, ByVal hRec As Long, ByVal Step As Long) As Long
  NextRec = InternalCFRONT.NextRec(hTable, hRec, Step)
End Function

Public Function InsertRec(ByVal hTable As Long, ByVal hRec As Long) As Boolean
  InsertRec = InternalCFRONT.InsertRec(hTable, hRec)
End Function

Public Function ModifyRec(ByVal hTable As Long, ByVal hRec As Long) As Boolean
  ModifyRec = InternalCFRONT.ModifyRec(hTable, hRec)
End Function

Public Function DeleteRec(ByVal hTable As Long, ByVal hRec As Long) As Boolean
  DeleteRec = InternalCFRONT.DeleteRec(hTable, hRec)
End Function

Public Sub DeleteRecs(ByVal hTable As Long)
  InternalCFRONT.DeleteRecs hTable
End Sub
'
' ------------------------------------------
' Field/Data routines
' ------------------------------------------
'
Public Sub SelectLatestVersion()
  InternalCFRONT.SelectLatestVersion
End Sub

Public Function GetFieldDataByName(ByVal hTable As Long, ByVal hRec As Long, _
    ByVal FieldName As String) As Variant
  GetFieldDataByName = InternalCFRONT.GetFieldData(hTable, hRec, InternalCFRONT.FieldNo(hTable, FieldName))
End Function

Public Function GetFlowFieldDataByNameAsDecimal(ByVal hTable As Long, ByVal hRec As Long, _
    ByVal FieldName As String) As Double
Dim FieldNameArray As Variant, FieldNoArray As Variant
  FieldNameArray = Array(FieldName)
  FieldNoArray = InternalCFRONT.FieldNoArray(hTable, FieldNameArray)
  InternalCFRONT.CalcFields hTable, hRec, FieldNoArray
  GetFlowFieldDataByNameAsDecimal = InternalCFRONT.GetFieldData(hTable, hRec, InternalCFRONT.FieldNo(hTable, FieldName))
End Function

Public Function GetFlowFieldDataByNameAsText(ByVal hTable As Long, ByVal hRec As Long, _
    ByVal FieldName As String) As String
Dim FieldNameArray As Variant, FieldNoArray As Variant
  FieldNameArray = Array(FieldName)
  FieldNoArray = InternalCFRONT.FieldNoArray(hTable, FieldNameArray)
  InternalCFRONT.CalcFields hTable, hRec, FieldNoArray
  GetFlowFieldDataByNameAsText = InternalCFRONT.GetFieldData(hTable, hRec, InternalCFRONT.FieldNo(hTable, FieldName))
End Function

Public Function GetFlowFieldDataByNameAsBoolean(ByVal hTable As Long, ByVal hRec As Long, _
    ByVal FieldName As String) As Boolean
Dim FieldNameArray As Variant, FieldNoArray As Variant
  FieldNameArray = Array(FieldName)
  FieldNoArray = InternalCFRONT.FieldNoArray(hTable, FieldNameArray)
  InternalCFRONT.CalcFields hTable, hRec, FieldNoArray
  GetFlowFieldDataByNameAsBoolean = InternalCFRONT.GetFieldData(hTable, hRec, InternalCFRONT.FieldNo(hTable, FieldName))
End Function

Public Function GetFlowFieldDataByNameAsDate(ByVal hTable As Long, ByVal hRec As Long, _
    ByVal FieldName As String) As Date
Dim FieldNameArray As Variant, FieldNoArray As Variant
  FieldNameArray = Array(FieldName)
  FieldNoArray = InternalCFRONT.FieldNoArray(hTable, FieldNameArray)
  InternalCFRONT.CalcFields hTable, hRec, FieldNoArray
  GetFlowFieldDataByNameAsDate = InternalCFRONT.GetFieldData(hTable, hRec, InternalCFRONT.FieldNo(hTable, FieldName))
End Function

Public Sub ClearCalcFields()
  CalcFieldsCount = 0
  ReDim CalcFieldsNameArr(1)
End Sub

Public Sub AddCalcField(ByVal FieldName As String)
  ReDim Preserve CalcFieldsNameArr(CalcFieldsCount + 1)
  CalcFieldsNameArr(CalcFieldsCount + 1) = FieldName
  CalcFieldsCount = CalcFieldsCount + 1
End Sub

Public Sub ExecuteCalcFields(ByVal hTable As Long, ByVal hRec As Long)
Dim i As Long, FieldNameArr() As String
  If FieldName1 = "" Then: Exit Sub
  i = 1
  If FieldName2 <> "" Then: i = 2
  If FieldName3 <> "" Then: i = 3
  If FieldName4 <> "" Then: i = 4
  If FieldName5 <> "" Then: i = 5
  If FieldName6 <> "" Then: i = 6
  If FieldName7 <> "" Then: i = 7
  If FieldName8 <> "" Then: i = 8
  If FieldName9 <> "" Then: i = 9
  If FieldName10 <> "" Then: i = 10
  If FieldName11 <> "" Then: i = 11
  ReDim FieldNameArr(i)
  FieldNameArr(0) = FieldName1
  If FieldName2 <> "" Then: FieldNameArr(1) = FieldName2
  If FieldName3 <> "" Then: FieldNameArr(2) = FieldName3
  If FieldName4 <> "" Then: FieldNameArr(3) = FieldName4
  If FieldName5 <> "" Then: FieldNameArr(4) = FieldName5
  If FieldName6 <> "" Then: FieldNameArr(5) = FieldName6
  If FieldName7 <> "" Then: FieldNameArr(6) = FieldName7
  If FieldName8 <> "" Then: FieldNameArr(7) = FieldName8
  If FieldName9 <> "" Then: FieldNameArr(8) = FieldName9
  If FieldName10 <> "" Then: FieldNameArr(9) = FieldName10
  If FieldName11 <> "" Then: FieldNameArr(10) = FieldName11
  CalcFieldsNoArr = InternalCFRONT.FieldNoArray(hTable, FieldsNameArr)
  InternalCFRONT.CalcFields hTable, hRec, CalcFieldsNoArr
End Sub

Public Function FieldOptionStr(ByVal hTable As Long, ByVal FieldName As String) As String
  FieldOptionStr = InternalCFRONT.FieldOptionStr(hTable, InternalCFRONT.FieldNo(hTable, FieldName))
End Function

Private Function GetOption(OptionStr As String, ByVal OptionNo As Integer)
    Dim B As Integer
    Dim E As Integer
    
    B = 1
    GetOption = Null
    Do
        E = InStr(B, OptionStr, ",")
                      
        If OptionNo = 0 Then
            If E = 0 Then E = Len(OptionStr) + 1
            GetOption = Mid(OptionStr, B, E - B)
            Exit Do
        End If

        OptionNo = OptionNo - 1
        B = E + 1
    Loop While E <> 0
End Function

Public Function GetOptionFieldValueAsString(ByVal hTable As Long, ByVal hRec As Long, _
    ByVal FieldName As String) As String
  Dim lValue As Long, lOptionStr As String
  
  lValue = InternalCFRONT.GetFieldData(hTable, hRec, InternalCFRONT.FieldNo(hTable, FieldName))
  lOptionStr = FieldOptionStr(hTable, FieldName)
  GetOptionFieldValueAsString = GetOption(lOptionStr, lValue)
End Function

Public Sub BWT()
  InternalCFRONT.BWT
End Sub

Public Sub EWT()
  InternalCFRONT.EWT
End Sub

Public Sub AWT()
  InternalCFRONT.AWT
End Sub

Public Sub AssignField_AsText(ByVal hTable As Long, ByVal hRec As Long, _
    ByVal FieldName As String, ByVal FieldValue As String)
Dim lValue As Variant
  lValue = FieldValue
  InternalCFRONT.AssignField hTable, hRec, InternalCFRONT.FieldNo(hTable, FieldName), lValue
End Sub

Public Sub AssignField_AsDecimal(ByVal hTable As Long, ByVal hRec As Long, _
    ByVal FieldName As String, ByVal FieldValue As Double)
Dim lValue As Variant
  lValue = FieldValue
  InternalCFRONT.AssignField hTable, hRec, InternalCFRONT.FieldNo(hTable, FieldName), lValue
End Sub

Public Sub AssignField_AsInteger(ByVal hTable As Long, ByVal hRec As Long, _
    ByVal FieldName As String, ByVal FieldValue As Long)
Dim lValue As Variant
  lValue = FieldValue
  InternalCFRONT.AssignField hTable, hRec, InternalCFRONT.FieldNo(hTable, FieldName), lValue
End Sub

Public Sub AssignField_AsBoolean(ByVal hTable As Long, ByVal hRec As Long, _
    ByVal FieldName As String, ByVal FieldValue As Boolean)
Dim lValue As Variant
  lValue = FieldValue
  InternalCFRONT.AssignField hTable, hRec, InternalCFRONT.FieldNo(hTable, FieldName), lValue
End Sub

Public Sub AssignField_AsDate(ByVal hTable As Long, ByVal hRec As Long, _
    ByVal FieldName As String, ByVal FieldValue As Date)
Dim lValue As Variant
  InternalCFRONT.AssignField hTable, hRec, InternalCFRONT.FieldNo(hTable, FieldName), lValue
End Sub

Public Sub AssignField_AsTime(ByVal hTable As Long, ByVal hRec As Long, _
    ByVal FieldName As String, ByVal FieldValue As Date)
Dim lValue As Variant
  lValue = FieldValue
  InternalCFRONT.AssignField hTable, hRec, InternalCFRONT.FieldNo(hTable, FieldName), lValue
End Sub

Public Function FieldToStr(ByVal hTable As Long, ByVal hRec As Long, _
    ByVal FieldName As String) As String
  FieldToStr = InternalCFRONT.FieldToStr(hTable, hRec, InternalCFRONT.FieldNo(hTable, FieldName))
End Function
'
' ------------------------------------------
' Filtering routines
' ------------------------------------------
'
Public Sub SetFilter(ByVal hTable As Long, ByVal FieldName As String, ByVal FilterStr As String)
  InternalCFRONT.SetFilter hTable, InternalCFRONT.FieldNo(hTable, FieldName), FilterStr
End Sub

Public Sub SetRange_TextField(ByVal hTable As Long, ByVal FieldName As String, _
    ByVal MinValue As String, ByVal MaxValue As String)
Dim lMinValue As Variant, lMaxValue As Variant
  lMinValue = MinValue
  lMaxValue = MaxValue
  InternalCFRONT.SetRange hTable, InternalCFRONT.FieldNo(hTable, FieldName), lMinValue, lMaxValue
End Sub

Public Sub SetRange_IntegerField(ByVal hTable As Long, ByVal FieldName As String, _
    ByVal MinValue As Long, ByVal MaxValue As Long)
Dim lMinValue As Variant, lMaxValue As Variant
  lMinValue = MinValue
  lMaxValue = MaxValue
  InternalCFRONT.SetRange hTable, InternalCFRONT.FieldNo(hTable, FieldName), lMinValue, lMaxValue
End Sub

Public Sub SetRange_DecimalField(ByVal hTable As Long, ByVal FieldName As String, _
    ByVal MinValue As Long, ByVal MaxValue As Double)
Dim lMinValue As Variant, lMaxValue As Variant
  lMinValue = MinValue
  lMaxValue = MaxValue
  InternalCFRONT.SetRange hTable, InternalCFRONT.FieldNo(hTable, FieldName), lMinValue, lMaxValue
End Sub

Public Sub SetRange_BoolField(ByVal hTable As Long, ByVal FieldName As String, _
    ByVal MinValue As Boolean, ByVal MaxValue As Boolean)
Dim lMinValue As Variant, lMaxValue As Variant
  lMinValue = MinValue
  lMaxValue = MaxValue
  InternalCFRONT.SetRange hTable, InternalCFRONT.FieldNo(hTable, FieldName), lMinValue, lMaxValue
End Sub

Public Sub SetRange_DateField(ByVal hTable As Long, ByVal FieldName As String, _
    ByVal MinValue As Date, ByVal MaxValue As Date)
Dim lMinValue As Variant, lMaxValue As Variant
  lMinValue = MinValue
  lMaxValue = MaxValue
  InternalCFRONT.SetRange hTable, InternalCFRONT.FieldNo(hTable, FieldName), lMinValue, lMaxValue
End Sub

Public Sub SetRange_TimeField(ByVal hTable As Long, ByVal FieldName As String, _
    ByVal MinValue As Date, ByVal MaxValue As Date)
Dim lMinValue As Variant, lMaxValue As Variant
  lMinValue = MinValue
  lMaxValue = MaxValue
  InternalCFRONT.SetRange hTable, InternalCFRONT.FieldNo(hTable, FieldName), lMinValue, lMaxValue
End Sub

Public Function GetFilter(ByVal hTable As Long, ByVal FieldName As String) As String
  GetFilter = InternalCFRONT.GetFilter(hTable, InternalCFRONT.FieldNo(hTable, FieldName))
End Function

'
' ------------------------------------------
' Additional routines (useful?)
' ------------------------------------------
'

Public Function TableName(ByVal hTable As Long) As String
  TableName = InternalCFRONT.TableName(hTable)
End Function

Public Function TableNo(ByVal TableName As String) As Long
  TableNo = InternalCFRONT.TableNo(TableName)
End Function

Public Function FieldName(ByVal hTable As Long, ByVal FieldNo As Long) As String
  FieldName = InternalCFRONT.FieldName(hTable, FieldNo)
End Function
